(*
Author:  Christian Sternagel <c.sternagel@gmail.com> (2011-2015)
Author:  René Thiemann <rene.thiemann@uibk.ac.at> (2011-2015)
License: LGPL (see file COPYING.LESSER)
*)
theory List_Order
imports
  Knuth_Bendix_Order.Order_Pair
begin

type_synonym 'a list_ext = "'a rel \<Rightarrow> 'a rel \<Rightarrow> 'a list rel"

locale list_order_extension =
  fixes s_list :: "'a list_ext"
   and ns_list :: "'a list_ext"
  assumes extension: "SN_order_pair S NS \<Longrightarrow> SN_order_pair (s_list S NS) (ns_list S NS)"
     and s_map: "\<lbrakk>\<And> a b. (a,b) \<in> S \<Longrightarrow> (f a,f b) \<in> S; \<And> a b. (a,b) \<in> NS \<Longrightarrow> (f a,f b) \<in> NS\<rbrakk> \<Longrightarrow> (as,bs) \<in> s_list S NS \<Longrightarrow> (map f as, map f bs) \<in> s_list S NS" 
     and ns_map: "\<lbrakk>\<And> a b. (a,b) \<in> S \<Longrightarrow> (f a,f b) \<in> S; \<And> a b. (a,b) \<in> NS \<Longrightarrow> (f a,f b) \<in> NS\<rbrakk> \<Longrightarrow> (as,bs) \<in> ns_list S NS \<Longrightarrow> (map f as, map f bs) \<in> ns_list S NS" 
     and all_ns_imp_ns: "length as = length bs \<Longrightarrow> \<lbrakk>\<And> i. i < length bs \<Longrightarrow>  (as ! i, bs ! i) \<in> NS\<rbrakk> \<Longrightarrow> (as,bs) \<in> ns_list S NS"

end
